;(function($) {
	var name_space = 'smoothScroller';
	$.fn[name_space] = function(options) {
		var defaults = {
			fps: 60,
			speed:0.1
		}
		var s = $.extend(defaults, options);
		var scrollTimer;
		var obj;
		return this.each(function(i){
			if(jQuery.support.fixedPosition) {
			    scrollTo(0,0);
				obj = $(this);
				$(window).data("scrollSmoothY",0);
				obj.parent().prepend('<div id="smoothScroller_page_height"></div>');
				obj.wrap('<div id="smoothScroller_page_wrap"></div>');
				obj = $("#smoothScroller_page_wrap");
				obj.css({
					position: "fixed",
					top: "0px",
					width: "100%"
				});
				$("#smoothScroller_page_height").height(obj.outerHeight(true));
				scrollSmooth();
				$(window).bind('resize scroll', function(e) {
					scrollSmooth();
				});
			}else{
			    $(window).bind('resize scroll', function(e) {
                    $(window).data("scrollSmoothY", $(window).scrollTop());
                    $(window).trigger("scrollSmooth");
                });
			}
		});

		function scrollSmooth() {
			if(scrollTimer) clearInterval(scrollTimer);
			var t = $(window).scrollTop();
			var p = obj.css("top").replace("px", "") * 1;
			var v = (t*-1 - p);
			var m = p + v * s.speed;
			var value = (Math.abs(v) < 1)? t*-1 : m*1;
			obj.css("top",value);
			if(Math.abs(v) >= 1){
				scrollTimer = setInterval(scrollSmooth,1000/s.fps);
			}
			$(window).data("scrollSmoothY", value * -1);
			$(window).trigger("scrollSmooth");
		}

		function isPositionFixedSupported() {
			var container = document.body;
			if (document.createElement &&
				container && container.appendChild && container.removeChild) {
				var el = document.createElement("div");
				if (!el.getBoundingClientRect) {
				    return null;
				}
				
				el.innerHTML = "x";
				el.style.cssText = "position:fixed;top:100px;";
				container.appendChild(el);
				
				var originalHeight = container.style.height, originalScrollTop = container.scrollTop;
				container.style.height = "3000px";
				container.scrollTop = 500;
				
				var elementTop = el.getBoundingClientRect().top;
				container.style.height = originalHeight;
				
				var isSupported = elementTop === 100;
				container.removeChild(el);
				
				container.scrollTop = originalScrollTop;
				alert(el.getBoundingClientRect());
				return isSupported;
				
			}
			return null;
		}
	};
})(jQuery);